
//
// Copyright (C) 2019, Order Flow Analytics Inc <www.orderflowanalytics.com>.
// OFA reserves the right to modify or overwrite this NinjaScript component with each release.
//
// By installing, using in whole or in part any sample code from Order Flow Analytics you agree to fully indemnify and hold harmless OrderFlowAnalytics, Inc 
// and its affiliates from and against any claims, losses, liabilities and expenses that may be incurred 
// as a result having downloaded and/or used any or all of the available code.
// Do thoroughly test any code & modifications for indicators and strategies in Replay Test mode

#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;

#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators
{
	public class OFASampleIndActiveProfileCwapVwap : Indicator
	{
		// Key reference needed to declare to access the Active Profile Data on the OFA Chart
		
		private OFAIndSTProfileAccess OFAIndSTPRACCESS1;
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "OFASampleIndActiveProfileCwapVwap";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= false;
				DrawVerticalGridLines						= false;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= false;
				
				AddPlot(Brushes.Transparent, "APCWAP");
				AddPlot(Brushes.Transparent, "APVWAP");
				
			}
			else if (State == State.Configure)
			{
				;
				
			}
			
			else if (State == State.DataLoaded)
			{				
				
				OFAIndSTPRACCESS1				= OFAIndSTProfileAccess(Close);
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here
			// For any indicator loaded into Bloodhound - can only be BarsInProgress == 0 ie the Primary Data Series
			
			if (BarsInProgress != 0) 
				return;

			if (CurrentBars[0] < 1)
				return;		
			
			// Before accessing Active Profile on the chart must always
			// Check an Active Profile is added and enabled before trying to access the data
			//
			
			if (OFAIndSTPRACCESS1.OFAIsActiveProfileEnabled)
			{
				
				APCWAP[0] = OFAIndSTPRACCESS1.OFAActiveProfileCwap;   
				APVWAP[0] = OFAIndSTPRACCESS1.OFAActiveProfileVwap;

			}
			else
			{
				APCWAP[0] = 0.0;   
				APVWAP[0] = 0.0;
			}
			Print("Cwap="); Print(APCWAP[0]);
			Print("Vwap="); Print(APVWAP[0]);
			
		
		}

		#region Properties

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> APCWAP
		{
			get { return Values[0]; }
		}
		
		[Browsable(false)]
		[XmlIgnore]
		public Series<double> APVWAP
		{
			get { return Values[1]; }
		}
		
		#endregion
		

	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private OFASampleIndActiveProfileCwapVwap[] cacheOFASampleIndActiveProfileCwapVwap;
		public OFASampleIndActiveProfileCwapVwap OFASampleIndActiveProfileCwapVwap()
		{
			return OFASampleIndActiveProfileCwapVwap(Input);
		}

		public OFASampleIndActiveProfileCwapVwap OFASampleIndActiveProfileCwapVwap(ISeries<double> input)
		{
			if (cacheOFASampleIndActiveProfileCwapVwap != null)
				for (int idx = 0; idx < cacheOFASampleIndActiveProfileCwapVwap.Length; idx++)
					if (cacheOFASampleIndActiveProfileCwapVwap[idx] != null &&  cacheOFASampleIndActiveProfileCwapVwap[idx].EqualsInput(input))
						return cacheOFASampleIndActiveProfileCwapVwap[idx];
			return CacheIndicator<OFASampleIndActiveProfileCwapVwap>(new OFASampleIndActiveProfileCwapVwap(), input, ref cacheOFASampleIndActiveProfileCwapVwap);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.OFASampleIndActiveProfileCwapVwap OFASampleIndActiveProfileCwapVwap()
		{
			return indicator.OFASampleIndActiveProfileCwapVwap(Input);
		}

		public Indicators.OFASampleIndActiveProfileCwapVwap OFASampleIndActiveProfileCwapVwap(ISeries<double> input )
		{
			return indicator.OFASampleIndActiveProfileCwapVwap(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.OFASampleIndActiveProfileCwapVwap OFASampleIndActiveProfileCwapVwap()
		{
			return indicator.OFASampleIndActiveProfileCwapVwap(Input);
		}

		public Indicators.OFASampleIndActiveProfileCwapVwap OFASampleIndActiveProfileCwapVwap(ISeries<double> input )
		{
			return indicator.OFASampleIndActiveProfileCwapVwap(input);
		}
	}
}

#endregion
